diff --git a/yum/drpm.py b/yum/drpm.py
new file mode 100644
index 0000000..cc680cd
--- /dev/null
+++ b/yum/drpm.py
@@ -0,0 +1,351 @@
+#  Integrated delta rpm support
+#  Copyright 2013 Zdenek Pavlas
+
+#   This library is free software; you can redistribute it and/or
+#   modify it under the terms of the GNU Lesser General Public
+#   License as published by the Free Software Foundation; either
+#   version 2.1 of the License, or (at your option) any later version.
+#
+#   This library is distributed in the hope that it will be useful,
+#   but WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+#   Lesser General Public License for more details.
+#
+#   You should have received a copy of the GNU Lesser General Public
+#   License along with this library; if not, write to the
+#      Free Software Foundation, Inc.,
+#      59 Temple Place, Suite 330,
+#      Boston, MA  02111-1307  USA
+
+from yum.constants import TS_UPDATE
+from yum.Errors import RepoError, MiscError
+from yum.i18n import exception2msg, _
+from yum.Errors import MiscError
+from yum.misc import checksum, repo_gen_decompress, unlink_f
+from urlgrabber import grabber, progress
+async = hasattr(grabber, 'parallel_wait')
+from xml.etree.cElementTree import iterparse
+import os, re
+
+APPLYDELTA = '/usr/bin/applydeltarpm'
+
+class DeltaPackage:
+    def __init__(self, rpm, size, remote, csum, oldrpm):
+        # copy what needed
+        self.rpm = rpm
+        self.repo = rpm.repo
+        self.basepath = rpm.basepath
+        self.pkgtup = rpm.pkgtup
+        (self.name, self.arch, self.epoch,
+         self.version, self.release) = self.pkgtup
+        self._hash = None
+
+        # set up drpm attributes
+        self.size = size
+        self.relativepath = remote
+        self.localpath = os.path.dirname(rpm.localpath) +'/'+ os.path.basename(remote)
+        self.csum = csum
+        self.oldrpm = oldrpm
+
+    def __str__(self):
+        return 'Delta RPM of %s' % self.rpm
+
+    def __cmp__(self, other):
+        if other is None:
+            return 1
+
+        #  Not a PackageObject(), so do this ourselves the bad way:
+        return (cmp(self.name, other.name) or
+                cmp(self.epoch, other.epoch) or
+                cmp(self.version, other.version) or
+                cmp(self.release, other.release) or
+                cmp(self.arch, other.arch))
+
+    def __hash__(self): # C&P from PackageObject...
+        if self._hash is None:
+            mystr = '%s - %s:%s-%s-%s.%s' % (self.repo.id, self.epoch, self.name,
+                                         self.version, self.release, self.arch)
+            self._hash = hash(mystr)
+        return self._hash
+
+    def localPkg(self):
+        return self.localpath
+
+    def getDiscNum(self):
+        return None
+
+    def verifyLocalPkg(self):
+        # check file size first
+        try: fsize = os.path.getsize(self.localpath)
+        except OSError: return False
+        if fsize != self.size: return False
+
+        # checksum
+        ctype, csum = self.csum
+        try: fsum = checksum(ctype, self.localpath)
+        except MiscError: return False
+        if fsum != csum: return False
+
+        # hooray
+        return True
+
+    def returnIdSum(self):
+        return self.csum
+
+def _num_cpus_online(unknown=1):
+    if not hasattr(os, "sysconf"):
+        return unknown
+
+    if not os.sysconf_names.has_key("SC_NPROCESSORS_ONLN"):
+        return unknown
+
+    ncpus = os.sysconf("SC_NPROCESSORS_ONLN")
+    try:
+        if int(ncpus) > 0:
+            return ncpus
+    except:
+        pass
+
+    return unknown
+
+class DeltaInfo:
+    def __init__(self, ayum, pkgs, adderror):
+        self.verbose_logger = ayum.verbose_logger
+        self.adderror = adderror
+        self.jobs = {}
+        self._future_jobs = []
+        self.progress = None
+        self.limit = ayum.conf.deltarpm
+        if self.limit < 0:
+            nprocs = _num_cpus_online()
+            self.limit *= -nprocs
+
+        if not self.limit: # Turned off.
+            return
+
+        # calculate update sizes
+        oldrpms = {}
+        pinfo = {}
+        reposize = {}
+        for index, po in enumerate(pkgs):
+            perc = po.repo.deltarpm_percentage
+            if perc is None:
+                urls = po.repo.urls
+                perc = ayum.conf.deltarpm_percentage
+                if len(urls) == 1 and urls[0].startswith('file:'):
+                    perc = 0 # for local repos, default to off.
+            if perc == 0:
+                continue # Allow people to turn off a repo. (meh)
+            if po.state == TS_UPDATE: pass
+            elif po.name in ayum.conf.installonlypkgs: pass
+            else:
+                names = oldrpms.get(po.repo)
+                if names is None:
+                    # load all locally cached rpms
+                    names = oldrpms[po.repo] = {}
+                    for rpmfn in os.listdir(po.repo.pkgdir):
+                        m = re.match('^(.+)-(.+)-(.+)\.(.+)\.rpm$', rpmfn)
+                        if m:
+                            n, v, r, a = m.groups()
+                            names.setdefault((n, a), set()).add((v, r))
+                if (po.name, po.arch) not in names:
+                    continue
+            pinfo.setdefault(po.repo, {})[po.pkgtup] = index
+            reposize[po.repo] = reposize.get(po.repo, 0) + po.size
+
+        # don't use deltas when deltarpm not installed
+        if reposize and not os.access(APPLYDELTA, os.X_OK):
+            self.verbose_logger.info(_('Delta RPMs disabled because %s not installed.'), APPLYDELTA)
+            return
+
+        # download delta metadata
+        mdpath = {}
+        for repo in reposize:
+            for name in ('prestodelta', 'deltainfo'):
+                try: data = repo.repoXML.getData(name); break
+                except: pass
+            else:
+                self.verbose_logger.info(_('No Presto metadata available for %s'), repo)
+                continue
+            path = repo.cachedir +'/'+ os.path.basename(data.location[1])
+            perc = repo.deltarpm_metadata_percentage
+            data_size = int(data.size) * (perc / 100.0)
+            if perc and not os.path.exists(path) and data_size > reposize[repo]:
+                msg = _('Not downloading deltainfo for %s, MD is %s and rpms are %s')
+                self.verbose_logger.info(msg, repo,
+                                         progress.format_number(data_size),
+                                         progress.format_number(reposize[repo]))
+                continue
+
+            def failfunc(e, name=name, repo=repo):
+                mdpath.pop(repo, None)
+                if hasattr(e, 'exception'): e = e.exception
+                self.verbose_logger.warn(_('Failed to download %s for repository %s: %s'),
+                                         name, repo, exception2msg(e))
+            kwargs = {}
+            if async and repo._async:
+                kwargs['failfunc'] = failfunc
+                kwargs['async'] = True
+            try: mdpath[repo] = repo._retrieveMD(name, **kwargs)
+            except RepoError, e: failfunc(e)
+        if async:
+            grabber.parallel_wait()
+
+        # parse metadata, create DeltaPackage instances
+        for repo, cpath in mdpath.items():
+            pinfo_repo = pinfo[repo]
+            path = repo_gen_decompress(cpath, 'prestodelta.xml',
+                                       cached=repo.cache)
+            for ev, el in iterparse(path):
+                if el.tag != 'newpackage': continue
+                name = el.get('name')
+                arch = el.get('arch')
+                new = name, arch, el.get('epoch'), el.get('version'), el.get('release')
+                index = pinfo_repo.get(new)
+                if index is not None:
+                    po = pkgs[index]
+                    perc = repo.deltarpm_percentage
+                    if perc is None:
+                        perc = ayum.conf.deltarpm_percentage
+                    best = po.size * (perc / 100.0)
+                    have = oldrpms.get(repo, {}).get((name, arch), {})
+                    for el in el.findall('delta'):
+                        size = int(el.find('size').text)
+                        if size >= best:
+                            continue
+
+                        # can we use this delta?
+                        epoch = el.get('oldepoch')
+                        ver = el.get('oldversion')
+                        rel = el.get('oldrelease')
+                        if (ver, rel) in have:
+                            oldrpm = '%s/%s-%s-%s.%s.rpm' % (repo.pkgdir, name, ver, rel, arch)
+                        else:
+                            if not ayum.rpmdb.searchNevra(name, epoch, ver, rel, arch):
+                                continue
+                            oldrpm = None
+
+                        best = size
+                        remote = el.find('filename').text
+                        csum = el.find('checksum')
+                        csum = csum.get('type'), csum.text
+                        pkgs[index] = DeltaPackage(po, size, remote, csum, oldrpm)
+                el.clear()
+
+    def wait(self, num=None):
+        """ Wait for "num" number of jobs to finish, or all of them. Blocks. """
+        if num is None:
+            num = len(self.jobs)
+
+        # wait for some jobs, run callbacks
+        while num > 0:
+            if not self.jobs: # This is probably broken logic, which is bad.
+                return
+            num -= self._wait(block=True)
+
+    def _wait(self, block=False):
+        num = 0
+
+        while self.jobs:
+            if block:
+                pid, code = os.wait()
+            else:
+                pid, code = os.waitpid(-1, os.WNOHANG)
+                if not pid:
+                    break
+
+            # urlgrabber spawns child jobs, too.  But they exit synchronously,
+            # so we should never see an unknown pid here.
+            assert pid in self.jobs
+            po = self.jobs.pop(pid)
+            if self.progress:
+                self.done += po.rpm.size
+                self.progress.update(self.done)
+            if code != 0:
+                unlink_f(po.rpm.localpath)
+                self.adderror(po, _('Delta RPM rebuild failed'))
+            elif not po.rpm.verifyLocalPkg():
+                self.adderror(po, _('Checksum of the delta-rebuilt RPM failed'))
+            else:
+                # done with drpm file, unlink when local
+                if po.localpath.startswith(po.repo.pkgdir):
+                    os.unlink(po.localpath)
+                # rename the rpm if --downloadonly
+                if po.rpm.localpath.endswith('.tmp'):
+                    rpmfile = po.rpm.localpath.rsplit('.', 2)[0]
+                    os.rename(po.rpm.localpath, rpmfile)
+                    po.rpm.localpath = rpmfile
+            num += 1
+
+            # when blocking, one is enough
+            if block:
+                break
+        return num
+
+    def rebuild(self, po):
+        """ Turn a drpm into an rpm, by adding it to the queue and trying to
+            service the queue. """
+        self._future_jobs.append(po)
+        self.dequeue_max()
+
+    def dequeue_all(self):
+        """ De-Queue all delta rebuilds and spawn the rebuild processes. """
+
+        count = total = 0
+        for po in self.jobs.values() + self._future_jobs:
+            count += 1
+            total += po.rpm.size
+        if total:
+            self.verbose_logger.info(_('Finishing delta rebuilds of %d package(s) (%s)'),
+                                     count, progress.format_number(total))
+            if po.repo.callback:
+                if hasattr(progress, 'text_meter_total_size'):
+                    progress.text_meter_total_size(0)
+                self.progress = po.repo.callback
+                # default timescale 5s works fine with 0.3s dl updates.
+                # drpm rebuild jobs do not finish that often, so bump it
+                try: self.progress.re.timescale = 30
+                except: pass # accessing private api
+                self.progress.start(filename=None, url=None, # BZ 963023
+                                    text='<locally rebuilding deltarpms>', size=total)
+                self.done = 0
+        while self._future_jobs:
+            self.dequeue()
+
+    def dequeue_max(self):
+        """ De-Queue all delta rebuilds we can and spawn the rebuild
+            processes. """
+
+        if not self._future_jobs:
+            # Just trim the zombies...
+            self._wait()
+            return
+
+        while self._future_jobs:
+            if not self.dequeue(block=False):
+                break
+
+    def dequeue(self, block=True):
+        """ Try to De-Queue a delta rebuild and spawn the rebuild process. """
+        # Do this here, just to keep the zombies at bay...
+        self._wait()
+
+        if not self._future_jobs:
+            return False
+
+        if self.limit <= len(self.jobs):
+            if not block:
+                return False
+            self.wait(len(self.jobs) - self.limit + 1)
+
+        po = self._future_jobs.pop(0)
+        args = ('-a', po.arch)
+        if po.oldrpm: args += '-r', po.oldrpm
+        args += po.localpath, po.rpm.localpath
+
+        try:
+            pid = os.spawnl(os.P_NOWAIT, APPLYDELTA, APPLYDELTA, *args)
+        except OSError, e:
+            raise MiscError, _('Couldn\'t spawn %s: %s') % (APPLYDELTA, exception2msg(e))
+        self.jobs[pid] = po
+        return True
diff --git a/yum/failover.py b/yum/failover.py
index bca9651..00c17ad 100644
--- a/yum/failover.py
+++ b/yum/failover.py
@@ -19,51 +19,80 @@
 # worry about calling get_serverurl() and server_failed() and these classes will 
 # figure out which URL to cough up based on the failover method.
 
+"""Classes for handling failovers for server URLs."""
+
 import random
 
 class baseFailOverMethod:
-
+    """A base class to provide a failover to switch to a new server if
+    the current one fails.
+    """
     def __init__(self, repo):
         self.repo = repo
         self.failures = 0
     
     def get_serverurl(self, i=None):
-        """Returns a serverurl based on this failover method or None 
-           if complete failure.  If i is given it is a direct index
-           to pull a server URL from instead of using the failures 
-           counter."""
+        """Return a server URL based on this failover method, or None
+        if there is a complete failure.  This method should always be
+        used to translate an index into a URL, as this object may
+        change how indexes map.
+
+        :param i: if given, this is the index of the server URL to
+           return, instead of using the failures counter
+        :return: the next server URL
+        """
         return None
         
     def server_failed(self):
-        "Tells the failover method that the current server is failed."
+        """Notify the failover method that the current server has
+        failed.
+        """
         self.failures = self.failures + 1
         
     def reset(self, i=0):
-        "Reset the failures counter to a given index."
+        """Reset the failures counter to the given index.
+
+        :param i: the index to reset the failures counter to
+        """
         self.failures = i
 
     def get_index(self):
-        """Returns the current number of failures which is also the
-           index into the list this object represents.  ger_serverurl()
-           should always be used to translate an index into a URL
-           as this object may change how indexs map.  (See RoundRobin)"""
+        """Return the current number of failures, which is also the
+        current index into the list of URLs that this object
+        represents.  :fun:`get_serverurl` should always be used to
+        translate an index into a URL, as this object may change how
+        indexes map.
 
+        :return: the current number of failures, which is also the
+           current index   
+        """
         return self.failures
    
     def len(self):
-        """Returns the how many URLs we've got to cycle through."""
+        """Return the total number of URLs available to cycle through
+        in this object.
 
+        :return: the total number of URLs available
+        """
         return len(self.repo.urls)
         
             
 
 class priority(baseFailOverMethod):
-
-    """Chooses server based on the first success in the list."""
-    
+    """A class to provide a failover to switch to a new server
+    if the current one fails.  This classes chooses the next server
+    based on the first success in the list of servers.
+    """
     def get_serverurl(self, i=None):
-        "Returns a serverurl based on this failover method or None if complete failure."
-        
+        """Return the next successful server URL in the list, or None
+        if there is a complete failure.  This method should always be
+        used to translate an index into a URL, as this object may
+        change how indexes map.
+
+        :param i: if given, this is the index of the server URL to
+           return, instead of using the failures counter
+        :return: the next server URL
+        """
         if i == None:
             index = self.failures
         else:
@@ -77,17 +106,28 @@ class priority(baseFailOverMethod):
         
     
 class roundRobin(baseFailOverMethod):
-
-    """Chooses server based on a round robin."""
-    
+    """A class to provide a failover to switch to a new server
+    if the current one fails.  When an object of this class is
+    created, it selects a random place in the list of URLs to begin
+    with, then each time :func:`get_serveurl` is called, the next URL
+    in the list is returned, cycling back to the beginning of the list
+    after the end is reached.
+    """
     def __init__(self, repo):
         baseFailOverMethod.__init__(self, repo)
         random.seed()
         self.offset = random.randint(0, 37)
     
     def get_serverurl(self, i=None):
-        "Returns a serverurl based on this failover method or None if complete failure."
+        """Return the next successful server URL in the list, using
+        the round robin scheme, or None if there is a complete
+        failure.  This method should always be used to translate an
+        index into a URL, as this object may change how indexes map.
 
+        :param i: if given, this is the index of the server URL to
+           return, instead of using the failures counter
+        :return: the next server URL
+        """
         if i == None:
             index = self.failures
         else:
diff --git a/yum/fssnapshots.py b/yum/fssnapshots.py
new file mode 100755
index 0000000..e912ea1
--- /dev/null
+++ b/yum/fssnapshots.py
@@ -0,0 +1,347 @@
+
+
+import os
+import fnmatch
+import time
+
+import subprocess
+
+try:
+    import lvm
+
+    #  Check that lvm2 is at least 2.2.99... In theory hacked versions of
+    # .98 work, but meh.
+
+    _ver = lvm.getVersion()
+    # Looks liks: 2.02.84(2) (2011-02-09)
+    _ver = _ver.split()[0]
+    _ver = _ver.split('(')[0]
+    _ver = tuple(map(int, _ver.split('.')))
+    if _ver < (2, 2, 99):
+        lvm = None
+except:
+    lvm = None
+    _ver = None
+
+
+def _is_origin(lv):
+    snap = lv.getProperty("lv_attr")
+    # snap=(<value>, <is settable>)
+    if not snap[0]: # Broken??
+        return None
+    return snap[0][0] in ('o', 'O')
+
+def _is_snap(lv):
+    snap = lv.getProperty("lv_attr")
+    # snap=(<value>, <is settable>)
+    if not snap[0]: # Broken??
+        return None
+    return snap[0][0] in ('s', 'S')
+
+def _is_virt(lv):
+    snap = lv.getProperty("lv_attr")
+    # snap=(<value>, <is settable>)
+    if not snap[0]: # Broken??
+        return None
+    return snap[0][0] == 'v'
+
+def _vg_name2lv(vg, lvname):
+    try:
+        return vg.lvFromName(lvname)
+    except:
+        return None
+
+def _list_vg_names():
+    names = lvm.listVgNames()
+
+    if not names: # Could be just broken...
+        if not os.path.exists("/sbin/lvm"):
+            return [] # Minimal install etc.
+
+        p = subprocess.Popen(["/sbin/lvm", "vgs", "-o", "vg_name"],
+                             stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+        err = p.wait()
+        if err:
+            return [] # Meh.
+
+        output = p.communicate()[0]
+        output = output.split('\n')
+        if not output:
+            return []
+        header = output[0].strip()
+        if header != 'VG':
+            return []
+        names = []
+        for name in output[1:]:
+            if not name:
+                break
+            names.append(name.strip())
+
+    return names
+
+def _z_off(z, ctime=0):
+    if len(z) == 5: # +0000 / -0130 / etc.
+        off = int(z[1:3]) * 60
+        off += int(z[3:5])
+        off *= 60
+        if z[0] == '+':
+            ctime -= off
+        if z[0] == '-':
+            ctime += off
+    return ctime
+
+def _lv_ctime2utc(ctime):
+    try: # Welcome to insanity ...
+        d,t,z = ctime.split()
+        ctime = time.strptime(d + ' ' + t, "%Y-%m-%d %H:%M:%S")
+
+        ctime = time.mktime(ctime)
+
+        if False: # Ignore the offset atm. ... we using this to delete older.
+            cur_z = time.strftime("%z")
+            if cur_z != z: # lol ...
+                cur_z = _z_off(cur_z)
+                z = _z_off(z)
+                ctime += (cur_z - z)
+
+    except:
+        ctime = 0
+
+    return ctime
+
+def _lv_data(vg, lv):
+    vgname = vg.getName()
+    lvname = lv.getName()
+
+    size = lv.getSize()
+    origin = lv.getProperty("origin")[0]
+    tags = lv.getTags()
+
+    ctime = _lv_ctime2utc(lv.getProperty("lv_time")[0])
+
+    used = lv.getProperty("snap_percent")[0]
+    used = float(used)
+    used = used / (1 * 1000 * 1000)
+
+    data = {'dev' : "%s/%s" % (vgname, lvname),
+            'ctime' : ctime,
+            'origin' : origin,
+            'origin_dev' : "%s/%s" % (vgname, origin),
+            'free' : vg.getFreeSize(),
+            'tags' : tags,
+            'size' : size,
+            'used' : used}
+
+    return data
+
+
+class _FSSnap(object):
+
+    # Old style was: vg/lv_root vg/lv_swap
+    # New style is: fedora/root fedora/swap
+    # New style is: redhat/root redhat/swap
+    def __init__(self, root="/", lookup_mounts=True,
+                 devices=('!*/swap', '!*/lv_swap')):
+        if not lvm or os.geteuid():
+            devices = []
+
+        self.version = _ver
+        self.available = bool(lvm)
+        self.postfix_static = "_yum_"
+        self._postfix = None
+        self._root = root
+        self._devs = devices
+        self._vgnames = []
+
+        if not self._devs:
+            return
+
+        self._vgnames = _list_vg_names()
+
+    def _use_dev(self, vgname, lv=None):
+
+        if lv is not None:
+            if _is_snap(lv) or _is_virt(lv): # Don't look at these.
+                return False
+
+        found_neg = False
+
+        for dev in self._devs:
+            if '/' not in dev: # Bad...
+                continue
+
+            neg = False
+            if dev[0] == '!':
+                found_neg = True
+                neg = True
+                dev = dev[1:]
+
+            vgn,lvn = dev.split('/', 1)
+            if '/' in lvn:
+                continue
+
+            if not fnmatch.fnmatch(vgname, vgn):
+                continue
+
+            if lvn == '*':
+                return not neg
+
+            if lv is None:
+                return None
+            lvname = lv.getName()
+
+            if not fnmatch.fnmatch(lvname, lvn):
+                continue
+
+            return not neg
+
+        return found_neg
+
+    def has_space(self, percentage=100):
+        """ See if we have enough space to try a snapshot. """
+
+        ret = False
+        for vgname in self._vgnames:
+            use = self._use_dev(vgname)
+            if use is not None and not use:
+                continue
+
+            vg = lvm.vgOpen(vgname, 'r')
+            if not vg:
+                return False
+
+            vgfsize = vg.getFreeSize()
+            lvssize = 0
+
+            for lv in vg.listLVs():
+                if not self._use_dev(vgname, lv):
+                    continue
+
+                lvssize += lv.getSize()
+
+            vg.close()
+
+            if not lvssize:
+                continue
+            ret = True
+
+            if (lvssize * percentage) > (100*vgfsize):
+                return False
+
+        return ret
+
+    def _get_postfix(self):
+        if self._postfix is None:
+            self._postfix = self.postfix_static
+            self._postfix += time.strftime("%Y%m%d%H%M%S")
+        return self._postfix
+
+    postfix = property(fget=lambda self: self._get_postfix(),
+                       fset=lambda self, value: setattr(self, "_postfix",value),
+                       fdel=lambda self: setattr(self, "_postfix", None),
+                       doc="postfix for snapshots")
+
+    def snapshot(self, percentage=100, prefix='', postfix=None, tags={}):
+        """ Attempt to take a snapshot, note that errors can happen after
+            this function succeeds. """
+
+        if postfix is None:
+            postfix = self.postfix
+
+        ret = []
+        for vgname in self._vgnames:
+            use = self._use_dev(vgname)
+            if use is not None and not use:
+                continue
+
+            vg = lvm.vgOpen(vgname, 'w')
+            if not vg:
+                return False
+
+            for lv in vg.listLVs():
+                lvname = lv.getName()
+
+                if not self._use_dev(vgname, lv):
+                    continue
+
+                nlvname = "%s%s%s" % (prefix, lvname, postfix)
+                nlv = lv.snapshot(nlvname, (lv.getSize() * percentage) / 100)
+                if not nlv: # Failed here ... continuing seems bad.
+                    vg.close()
+                    return None
+
+                odev = "%s/%s" % (vgname,  lvname)
+                ndev = "%s/%s" % (vgname, nlvname)
+
+                # FIXME: yum_fssnapshot_pre_lv_name=<blah>
+                eq_tags = set()
+                for val in (ndev, odev, '*'):
+                    for tag in tags.get(val, []):
+                        if '=' in tag:
+                            eq_tag_key,eq_tag_val = tag.split('=', 1)
+                            if eq_tag_key in eq_tags:
+                                continue
+                            eq_tags.add(eq_tag_key)
+
+                        nlv.addTag(tag)
+
+                ret.append((odev, ndev))
+
+            vg.close()
+
+        return ret
+
+    def old_snapshots(self):
+        """ List data for old snapshots. """
+
+        ret = []
+        for vgname in self._vgnames:
+            #  We could filter out the VGs using _use_dev() but this way we'll
+            # see stuff after changing config. options.
+
+            vg = lvm.vgOpen(vgname, 'w')
+
+            for lv in vg.listLVs():
+
+                if not _is_snap(lv): # No snapshot means, we don't care.
+                    continue
+
+                ret.append(_lv_data(vg, lv))
+            vg.close()
+
+        return ret
+
+    def del_snapshots(self, devices=[]):
+        """ Remove snapshots. """
+
+        if not lvm:
+            return []
+
+        ret = []
+
+        togo = {}
+        for dev in devices:
+            vgname,lvname = dev.split('/')
+            if vgname not in togo:
+                togo[vgname] = set([lvname])
+            else:
+                togo[vgname].add(lvname)
+
+        for vgname in togo:
+            vg = lvm.vgOpen(vgname, 'w')
+
+            for lvname in togo[vgname]:
+                lv = _vg_name2lv(vg, lvname)
+                if not lv:
+                    continue
+
+                if not _is_snap(lv): # No snapshot means don't try to delete!
+                    continue
+
+                ret.append(_lv_data(vg, lv))
+
+                lv.remove()
+
+            vg.close()
+
+        return ret
